require "GDL2.ArrayList"
require "GDL2.StackToken"
require "GDL2.SkeletonData"
require "GDL2.SequenceToken"

--Engine Variables
GDLStack = ArrayList:new()
ExampleSkeletonData = SkeletonData:new()

function GetExampleSkeletonData()
	return copy2(ExampleSkeletonData)
end

function copy2(obj)
  if type(obj) ~= 'table' then return obj end
  local res = setmetatable({}, getmetatable(obj))
  for k, v in pairs(obj) do res[copy2(k)] = copy2(v) end
  return res
end

function PreReturnConclusions(ActualSkeletonData, TimePeriod)
	st = StackToken:new()
	st.Skeleton = ActualSkeletonData
	st.TimePeriod = TimePeriod
	--if (GDLStack == nil) then
	--	GDLStack = ArrayList:new()
	--end
	GDLStack:addToken(st)
end

function PostReturnConclusions(st)
	Features = {}
	Conclusions = {}
	for n,v in pairs(_G) do
		--Features[n] = v
		if (type(v) == 'number') then
			--print (n,v)
			Features[n] = v
		end
		if (type(v) == 'table' and n ~= 'Vector3D') then
			if (v.__class ~= nil) then
				if (v.__class == 'Vector3D') then
			--print (n,v)
					Features[n] = v
				end
			end
		end
		if (type(v) == 'boolean') then
			--print (n,v)
			Conclusions[n] = v
		end
	end
		
	st.Features = Features
	st.Conclusions = Conclusions
	GDLStack.StackTokens[1] = st
end

function splitSequence(inputstr)
	local t={}
	local sequence = {}
	local str = 'aaa'
	
	local splittedString = string.gmatch(inputstr, "%[[^%]]+")
	
	for str in splittedString do
		--now each sequence component is separate string
		--remove '['
		str = string.sub(str, 2)
		local Conclusions = {}
		local Prefixes = {}
		local splittedString2 = string.gmatch(str, "[^,]+")
		local str2 = 'aaa'
		for str2 in splittedString2 do
--	for str2 in splittedString2 do
			if (str2 ~= '') then
				if (string.sub(str2, 1, 1) == '!') then
					table.insert(Prefixes, true)
					table.insert(Conclusions, string.sub(str2, 2))
				else
					table.insert(Prefixes, false)
					table.insert(Conclusions, str2)
				end
			end
		end
		local TimeConstraintSeconds = tonumber(table.remove(Conclusions))
		table.remove(Prefixes)
		local st = SequenceToken:new()
		st.Conclusions = Conclusions
		st.Prefixes = Prefixes
		
		st.TimeConstraintSeconds = TimeConstraintSeconds
		table.insert(sequence, st)
	end

	return sequence
end

function printSequence(sequence)
	local loopCount = 0
	local i = 0
	local j = 0
	for Index, Value in pairs( sequence ) do
		loopCount = loopCount + 1
	end
	
	--if (sequence ~= nil) then
	--	loopCount = table.getn(sequence)
	--end

	for i=1,loopCount do
		local loopCount2 = 0
		for Index, Value in pairs( sequence[i].Conclusions ) do
			loopCount2 = loopCount2 + 1
		end
		--if (sequence[i].Conclusions ~= nil) then
		--	loopCount2 = table.getn(sequence[i].Conclusions)
		--end
		for j=1,loopCount2 do
			print(sequence[i].Conclusions[j])
			print(sequence[i].Prefixes[j])
		end
		print(sequence[i].TimeConstraintSeconds)
	end
end

function sequenceexists(inputstr)
	
	sequence = splitSequence(inputstr)
	local i = 0
	local j = 0
	--dupa = {}
	--table.insert(dupa, sequence[1].Conclusions[1])
	--table.insert(dupa, sequence[1].Prefixes[1])
	--table.insert(dupa, sequence[1].TimeConstraintSeconds)
	
	
	local loopCount = 0
	--if (sequence ~= nil) then
	--	loopCount = table.getn(sequence)
	--end
	for Index, Value in pairs( sequence ) do
		loopCount = loopCount + 1
	end
	
	local timePeriod = 0;
	local maxC = 1;
	local maxCTemp = 1
	local c = 1
	
	
	
	for i=1,loopCount do
		--timePeriod = 0;
		local loopCount2 = 0
		--if (sequence[i].Conclusions ~= nil) then
		--	loopCount2 = table.getn(sequence[i].Conclusions)
		--end
		for Index, Value in pairs( sequence[i].Conclusions ) do
			loopCount2 = loopCount2 + 1
		end
		
		--[[dupa = {}
		table.insert(dupa, sequence[i].Conclusions[1])
		table.insert(dupa, sequence[i].Prefixes[1])
		table.insert(dupa, sequence[i].TimeConstraintSeconds)
		zz = 1
		if (zz == 1) then return true end]]
		
		for j=1,loopCount2 do
			--zerujemy okres czasu
			timePeriod = 0;
			--startujemy od pozycji na stosie, na ktrej zakoczylimy analiz poprzedniego tokena sekwencji
			c = maxC
			local stringInArray = false
			repeat
				--jeli wicje ni rozmiar stosu - koniec
				local stackSize = 0
				for Index, Value in pairs( GDLStack.StackTokens ) do
					stackSize = stackSize + 1
				end
				
				--if (c > table.getn(GDLStack.StackTokens)) then
				if (c > stackSize) then
					timePeriod = sequence[i].TimeConstraintSeconds + 1;
				else
					--pobieramy ze stosu tak dugo, a znajdiezmy sekwencj, albo przekroczymy czas (ale zawsze conajmniej raz)
					stringInArray = GDLStack.StackTokens[c].Conclusions[sequence[i].Conclusions[j]]
					timePeriod = timePeriod + GDLStack.StackTokens[c].TimePeriod
					c = c + 1
				end
			until (stringInArray or timePeriod > sequence[i].TimeConstraintSeconds)
			--jeli nie znalelismy konkluzji, to znaczy, e przekroczylimy limit czasu
			if ((not stringInArray) and (not sequence[i].Prefixes[j])) then
				return false
			end
			--jeli jest zaprzeczenie - to przy znalezieniu konkluzji jest to nieprawda
			if (stringInArray and sequence[i].Prefixes[j]) then
				return false
			end
			--zapamitujemy najduszy do to pory czas (to znaczy ile musielimy przegldn na gboko w stosie, eby znale t sekwencj
			if (maxCTemp < c) then
				maxCTemp = c;
			end
		end
		--ustaw startow pozycj stosu na ostatnio uyt +1
		maxC = maxCTemp + 1
	end
	return true
end

function rulepersists(conclusion, persistaceTime, persistancePercentage)

	if type(conclusion) ~= 'string' then
		error("Conclusion in rulepersists is not a string")
	end

	local c = 1
	local tm = nil
	local timePeriod = 0
	local stringInArray = false;
	local conclusionsCount = 0;
	repeat
		local stackSize = 0
		for Index, Value in pairs( GDLStack.StackTokens ) do
			stackSize = stackSize + 1
		end
		--jeli wicje ni rozmiar stosu - koniec
		--if (c > table.getn(GDLStack.StackTokens)) then
		if (c > stackSize) then
			timePeriod = persistaceTime + 1;
		else
			--pobieramy ze stosu tak dugo, a znajdiezmy sekwencj, albo przekroczymy czas (ale zawsze conajmniej raz)
			--tm = GDLStack.StackTokens[c]

			timePeriod = timePeriod + GDLStack.StackTokens[c].TimePeriod
			--stringInArray = StringInArray(conclusion, tm.Conclusions);
			stringInArray = GDLStack.StackTokens[c].Conclusions[conclusion]
			if (stringInArray) then
				conclusionsCount = conclusionsCount + 1
			end
			c = c + 1
		end
	until (timePeriod >= persistaceTime);
	local percentageResult = conclusionsCount / (c - 1)
	if (percentageResult >= persistancePercentage) then
		return true
	end
	return false
end

function SpineBase(level)
	return GDLStack:Level(level).Skeleton.SpineBase
end

function SpineMid(level)
	return GDLStack:Level(level).Skeleton.SpineMid
end

function Neck(level)
	return GDLStack:Level(level).Skeleton.Neck
end

function Head(level)
	return GDLStack:Level(level).Skeleton.Head
end

function ShoulderLeft(level)
	return GDLStack:Level(level).Skeleton.ShoulderLeft
end

function ElbowLeft(level)
	return GDLStack:Level(level).Skeleton.ElbowLeft
end

function WristLeft(level)
	return GDLStack:Level(level).Skeleton.WristLeft
end

function HandLeft(level)
	return GDLStack:Level(level).Skeleton.HandLeft
end

function ShoulderRight(level)
	return GDLStack:Level(level).Skeleton.ShoulderRight
end

function ElbowRight(level)
	return GDLStack:Level(level).Skeleton.ElbowRight
end

function WristRight(level)
	return GDLStack:Level(level).Skeleton.WristRight
end

function HandRight(level)
	return GDLStack:Level(level).Skeleton.HandRight
end

function HipLeft(level)
	return GDLStack:Level(level).Skeleton.HipLeft
end

function KneeLeft(level)
	return GDLStack:Level(level).Skeleton.KneeLeft
end

function AnkleLeft(level)
	return GDLStack:Level(level).Skeleton.AnkleLeft
end

function FootLeft(level)
	return GDLStack:Level(level).Skeleton.FootLeft
end

function HipRight(level)
	return GDLStack:Level(level).Skeleton.HipRight
end

function KneeRight(level)
	return GDLStack:Level(level).Skeleton.KneeRight
end

function AnkleRight(level)
	return GDLStack:Level(level).Skeleton.AnkleRight
end

function FootRight(level)
	return GDLStack:Level(level).Skeleton.FootRight
end

function SpineShoulder(level)
	return GDLStack:Level(level).Skeleton.SpineShoulder
end

function HandTipLeft(level)
	return GDLStack:Level(level).Skeleton.HandTipLeft
end

function ThumbLeft(level)
	return GDLStack:Level(level).Skeleton.ThumbLeft
end

function HandTipRight(level)
	return GDLStack:Level(level).Skeleton.HandTipRight
end

function ThumbRight(level)
	return GDLStack:Level(level).Skeleton.ThumbRight
end


function abs(value)
	return math.abs(value)
end
